#include "delay.h"
#include "SI4432.h"
#include "STC15.h"

#define TxBuf_Len 10 
#define RxBuf_Len 10     //RF4432ݰ

unsigned char RxBuf[RxBuf_Len];
unsigned char TxBuf[TxBuf_Len] = {0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x6d};  //ÿ뷢Ĺ̶ݵĲźţ10ǰ9ݵУֱͣΪ656667686970717273109
unsigned char ItStatus;  //ͽж
unsigned char RSSI;      //RSSI

unsigned char count_50hz;
unsigned char ItStatus1,ItStatus2;
unsigned char rf_timeout;



FlagType Flag;

#define SI4432_PWRSTATE_READY		0x01		// ģ Ready ״̬
#define SI4432_PWRSTATE_TX		0x09		// ģ ״̬
#define SI4432_PWRSTATE_RX		0x05		// ģ ״̬
#define SI4432_PACKET_SENT_INTERRUPT	0x04		// ģ ж
#define SI4432_Rx_packet_received_interrupt   0x02      // ģ յݰж


//Mini STM32
//NRF24L01  
//ԭ@ALIENTEK
//2010/6/16	
//sbit KEY = P3^0;
sbit KEY = P2^6;	 //KEY3
//sbit LED=P0^0;
sbit LED=P2^4;		 //GLED
sbit RLED=P2^5;		 //RLED
//---------------------------------------------- 
//sbit NSS = P1 ^ 3; //spi ce
sbit NSS = P1 ^ 0; //spi ce
//sbit NIRQ= P1 ^ 0;
sbit NIRQ= P3 ^ 2;
//sbit SDNN= P1 ^ 1;	//chip ce
sbit SDNN= P0 ^ 0;	//chip ce
//sbit SCK = P1 ^ 2; 
sbit SCK = P1 ^ 3; 
//sbit MOSI = P1 ^ 5;
sbit MOSI = P1 ^ 2;
//sbit MISO = P1 ^ 4;
sbit MISO = P1 ^ 1;

bdata unsigned char st=0;
sbit st_1=st^0;
sbit st_2=st^1;
sbit st_3=st^2;
sbit st_4=st^3;
sbit st_5=st^4;
sbit st_6=st^5;
sbit st_7=st^6;
sbit st_8=st^7;
bdata unsigned char st1=0;
sbit st_11=st1^0;
sbit st_12=st1^1;
sbit st_13=st1^2;
sbit st_14=st1^3;
sbit st_15=st1^4;
sbit st_16=st1^5;
sbit st_17=st1^6;
sbit st_18=st1^7;

unsigned char KEY_Scan(void)
{	 	
	if(KEY==0)
	{
		delay_ms(10);//ȥ 
		if(KEY==0)
		{
			return 1;
		}
	}	    
	return 0;// ް
}
unsigned char SPI_RW(unsigned char byte)
{
	//uchar bit_ctr;

    st=byte;

    MOSI=st_8;
    SCK = 1;
    st_18=MISO;
    SCK = 0;

    MOSI=st_7;
    SCK = 1;
    st_17=MISO;
    SCK = 0;

    MOSI=st_6;
    SCK = 1;
    st_16=MISO;
    SCK = 0;

    MOSI=st_5;
    SCK = 1;
    st_15=MISO;
    SCK = 0;

    MOSI=st_4;
    SCK = 1;
    st_14=MISO;
    SCK = 0;

    MOSI=st_3;
    SCK = 1;
    st_13=MISO;
    SCK = 0;

    MOSI=st_2;
    SCK = 1;
    st_12=MISO;
    SCK = 0;

    MOSI=st_1;
    SCK = 1;
    st_11=MISO;
    SCK = 0;


    return(st1);           		  // return read byte
}
	 


unsigned char SPI_RW_Reg(unsigned char addr, unsigned char data_)
{
	unsigned char status;
	
	NSS = 0;
	SPI_RW(addr);
	status = SPI_RW(data_);
	NSS = 1;
	
	return(status);
}
void SPI_Read_Buf(unsigned char addr, unsigned char *data_, unsigned char number)
{
	int number_ctr;
	
	NSS = 0;
	SPI_RW(addr);
	for(number_ctr=0;number_ctr<number;number_ctr++)
	data_[number_ctr] = SPI_RW(0);
	NSS = 1;
}
void SPI_Write_Buf(unsigned char addr, unsigned char *data_, unsigned char number)
{
	unsigned char number_ctr;
	NSS = 0;  
	SPI_RW(addr);   
	for(number_ctr=0; number_ctr<number; number_ctr++)
	SPI_RW(*data_++);
	NSS = 1;
}

void Si4432_init(void)
{
//	SPI_Init();	    
    unsigned char a=0;
	//si4432_Init();
	SDNN = 1;
 	delay_ms(10);	// RF ģϵ縴λ
 	
 	SDNN = 0;
	delay_ms(500);
	a=SPI_RW_Reg(READREG + 0x03, 0x00);	 //RFģж	
	a=SPI_RW_Reg(READREG + 0x04, 0x00);
	
	SPI_RW_Reg(WRITEREG + 0x06, 0x80);  //ʹͬ
	SPI_RW_Reg(WRITEREG + 0x07, 0x01);  // Ready ģʽ
	
//	SPI_RW_Reg(WRITEREG + 0x09, 0x7f);  //ص= 12P
	SPI_RW_Reg(WRITEREG + 0x09, 0xD7);  //ص= 9P
	SPI_RW_Reg(WRITEREG + 0x69, 0x60);  //AGC
	SPI_RW_Reg(WRITEREG + 0x0a, 0x05);  //رյƵ
	SPI_RW_Reg(WRITEREG + 0x0b, 0xea);  //GPIO 0 ͨ
	SPI_RW_Reg(WRITEREG + 0x0c, 0xea);  //GPIO 1 ͨ
//	SPI_RW_Reg(WRITEREG + 0x0b, 0x15);  //GPIO 0 RX
//	SPI_RW_Reg(WRITEREG + 0x0c, 0x12);  //GPIO 1 TX
	SPI_RW_Reg(WRITEREG + 0x0d, 0xf4);  //GPIO 2 յ
//	SPI_RW_Reg(WRITEREG + 0x0c, 0xea);  //GPIO 1 ͨ
//	SPI_RW_Reg(WRITEREG + 0x0d, 0xf4);  //GPIO 2 յ
	SPI_RW_Reg(WRITEREG + 0x70, 0x2c);  
	SPI_RW_Reg(WRITEREG + 0x1d, 0x40);  //ʹ afc
	
	// 1.2K bps setting
//-------rx bw------------------------
	SPI_RW_Reg(WRITEREG + 0x1c, 0x16);  //16NibblePreamble
	SPI_RW_Reg(WRITEREG + 0x20, 0x83);   
	SPI_RW_Reg(WRITEREG + 0x21, 0xc0);  //
	SPI_RW_Reg(WRITEREG + 0x22, 0x13);  // 
	SPI_RW_Reg(WRITEREG + 0x23, 0xa9);  //
	SPI_RW_Reg(WRITEREG + 0x24, 0x00);  //
//	SPI_RW_Reg(WRITEREG + 0x25, 0x04);  //
	SPI_RW_Reg(WRITEREG + 0x25, 0x03);  //
	SPI_RW_Reg(WRITEREG + 0x2a, 0x14);
//----data rate------------------
	SPI_RW_Reg(WRITEREG + 0x6e, 0x09);
	SPI_RW_Reg(WRITEREG + 0x6f, 0xd5);
	//1.2K bps setting end		
	
	SPI_RW_Reg(WRITEREG + 0x30, 0x8c);  //ʹPH+ FIFOģʽλǰ棬ʹCRCУ
	SPI_RW_Reg(WRITEREG + 0x32, 0xff);  //byte0, 1,2,3 Ϊͷ
	SPI_RW_Reg(WRITEREG + 0x33, 0x42);  //byte 0,1,2,3 ͷ룬ͬ3,2 ͬ
	SPI_RW_Reg(WRITEREG + 0x34, 16);    //16NibblePreamble
	SPI_RW_Reg(WRITEREG + 0x35, 0x20);  //Ҫ4nibblePreamble
	SPI_RW_Reg(WRITEREG + 0x36, 0x2d);  //ͬΪ 0x2dd4
	SPI_RW_Reg(WRITEREG + 0x37, 0xd4);
	SPI_RW_Reg(WRITEREG + 0x38, 0x00);
	SPI_RW_Reg(WRITEREG + 0x39, 0x00);
	SPI_RW_Reg(WRITEREG + 0x3a, 'H');   //ͷΪ HRWT"
	SPI_RW_Reg(WRITEREG + 0x3b, 'R');
	SPI_RW_Reg(WRITEREG + 0x3c, 'W');
	SPI_RW_Reg(WRITEREG + 0x3d, 'T');
	SPI_RW_Reg(WRITEREG + 0x3e, 10);    //ܹ10ֽڵ
	SPI_RW_Reg(WRITEREG + 0x3f, 'H');   //ҪУͷΪHRWT"
	SPI_RW_Reg(WRITEREG + 0x40, 'R');
	SPI_RW_Reg(WRITEREG + 0x41, 'W');
	SPI_RW_Reg(WRITEREG + 0x42, 'T');
	SPI_RW_Reg(WRITEREG + 0x43, 0xff);  //ͷ1,2,3,4 λҪУ
	SPI_RW_Reg(WRITEREG + 0x44, 0xff);  // 
	SPI_RW_Reg(WRITEREG + 0x45, 0xff);  // 
	SPI_RW_Reg(WRITEREG + 0x46, 0xff);  // 
//--------------------------------------------------------------------------
//	SPI_RW_Reg(WRITEREG + 0x6d, 0x06);  //书  0x00:+0dBM  0x01:+3dBM  0x02:+6dBM  0x03:+9dBM  0x04:+11dBM  0x05:+14dBM  0x06:+17dBM  0x07:20dBM
    SPI_RW_Reg(WRITEREG + 0x6d, 0x07);
	SPI_RW_Reg(WRITEREG + 0x79, 0x0);   //ҪƵ
	SPI_RW_Reg(WRITEREG + 0x7a, 0x0);   //ҪƵ
//	SPI_RW_Reg(WRITEREG + 0x71, 0x22);  //䲻ҪCLKFiFoFSKģʽ
	SPI_RW_Reg(WRITEREG + 0x71, 0x2B); 	// 䲻ҪCLKFiFo GFSKģʽ
	SPI_RW_Reg(WRITEREG + 0x72, 0x30);  //ƵƫΪ 30KHz
	SPI_RW_Reg(WRITEREG + 0x73, 0x0);   //ûƵƫ
	SPI_RW_Reg(WRITEREG + 0x74, 0x0);   //ûƵƫ
//----------------------------------------------------------------
	SPI_RW_Reg(WRITEREG + 0x75, 0x53);  //Ƶ 434
	SPI_RW_Reg(WRITEREG + 0x76, 0x64);  //
	SPI_RW_Reg(WRITEREG + 0x77, 0x00);
	TX0_RX0;	// ߿زڷ䣬״̬
}
unsigned char RF4432_RSSI(void)
{	
	if(!(NIRQ))
	{
		ItStatus = SPI_RW_Reg(READREG + 0x04,0x00);  //жϼĴ
	 	if((ItStatus&0x80)==0x80)
		{
			RSSI = SPI_RW_Reg(READREG + 0x26, 0x00);
		    return 1;
		}
		else
		{
		    return 0;
		}
	}
	else
	{
	return 0;
	}
}
unsigned char RF4432_RxPacket(unsigned char *rxBuffer)
{	
	if(!(NIRQ))
	{		
		ItStatus = SPI_RW_Reg(READREG + 0x03,0x00);  //жϼĴ
	 	if((ItStatus&0x02)==0x02)
		{
		    
		    SPI_Read_Buf(0x7f, rxBuffer, RxBuf_Len);
		    return 1;
		}
		else
		{
		    return 0;
		}
	}
	else
	{
	return 0;
	}
}
void RF4432_TxPacket(unsigned char *dataBuffer)
{
    unsigned char TX_Timeout;
	SPI_RW_Reg(WRITEREG + 0x34, 40);   //40Nibble ǰ
	SPI_RW_Reg(WRITEREG + 0x3e, TxBuf_Len);  //ܹ10ֽڵ
	
	SPI_Write_Buf(WRITEREG + 0x7f, dataBuffer, TxBuf_Len);   //Ҫ͵дĴ
    SPI_RW_Reg(WRITEREG + 0x07, 0x09); //뷢ģʽ	
	
	TX_Timeout = 0;
	while(NIRQ)		//ȴж
	{
	   TX_Timeout++;
		if(TX_Timeout>=100)
		{
		    //Uart_sentstr("ʧ...TX ERROR\r\n");
		    TX_Timeout=0;
			delay_ms(200);
			
			Si4432_init();
			
			break;		//ǿ
		}
		delay_ms(5);
	}

	if(!(NIRQ))
	{
		ItStatus = SPI_RW_Reg(READREG + 0x03,0x00);  //жϼĴ
		if((ItStatus&0x04)==0x04)
		{
		  ItStatus=0  ;//Uart_sentstr("ͳɹ...TX OK\r\n");
		}
	}
}
void SetRX_Mode(void)
{	
	SPI_RW_Reg(WRITEREG + 0x07, 0x01);	// Ready ģʽ
	delay_ms(5);
	TX0_RX1;		//߿
//    TX1_RX0;
    delay_ms(5);

	SPI_RW_Reg(WRITEREG + 0x08, SPI_RW_Reg(READREG + 0x08, 0x00)|0x02); //FIFO0
	SPI_RW_Reg(WRITEREG + 0x08, SPI_RW_Reg(READREG + 0x08, 0x00)&0xFD);
	
	SPI_RW_Reg(READREG + 0x03, 0x00);	 //ежϱ־
	
	SPI_RW_Reg(WRITEREG + 0x05, 0x02);  //RFģյݺ󣬲ж
	SPI_RW_Reg(WRITEREG + 0x07, 0x05);  //RF ģģʽ
}
void SetTX_Mode(void)
{
	SPI_RW_Reg(WRITEREG + 0x07, 0x01);	//rfģReadyģʽ
	delay_ms(5);
	TX1_RX0;		//߿صķ

//    TX0_RX1;
	delay_ms(5);
	
	SPI_RW_Reg(WRITEREG + 0x08, SPI_RW_Reg(READREG + 0x08, 0x00)|0x01); //FIFO0
	SPI_RW_Reg(WRITEREG + 0x08, SPI_RW_Reg(READREG + 0x08, 0x00)&0xFE);
	
	SPI_RW_Reg(READREG + 0x03, 0x00);  //ежϱ־
	
	SPI_RW_Reg(WRITEREG + 0x05, 0x04);	//ݷ󣬲ж
	delay_ms(5);
//	TX0_RX0;
}



	
void test_al(void)
{
	uchar i, chksum;
	uchar RSSI_Buf[4];
    uchar RSSI_Timeout=0;
	uchar re_re=0;
		LED=0;
	delay_ms(50);
	LED=1;
	delay_ms(50);
	LED=0;
	delay_ms(50);
	LED=1;
 	Si4432_init();    //ʼSS4432
  
    //Uart_sentstr("ɹ...................START\r\n");
	LED=0;
	delay_ms(50);
	LED=1;
	delay_ms(50);
	LED=0;
	delay_ms(50);
	LED=1;
	SetRX_Mode();
	while(1)
	{	
	/*	if(RF4432_RSSI())  //нʱRSSIֵ
		{
		    RSSI_Timeout=0;
		   // Uart_sentstr("źǿ...");
			RSSI_Buf[0]=RSSI/100 + 0x30;
	        RSSI_Buf[1]=RSSI%100/10 + 0x30;
	        RSSI_Buf[2]=RSSI%10 + 0x30;
			RSSI_Buf[3]='\0';
			if(RSSI_Buf[0])
			RSSI_Buf[0]=0;
			//Uart_sentstr(RSSI_Buf);
		    //Uart_sentstr("\r\n");
		}
		else if(RSSI_Timeout>200)
		{
		    RSSI_Timeout=0;
		    //Uart_sentstr("źǿ...");
			RSSI = SPI_RW_Reg(READREG + 0x26, 0x00);
			RSSI_Buf[0]=RSSI/100 + 0x30;
	        RSSI_Buf[1]=RSSI%100/10 + 0x30;
	        RSSI_Buf[2]=RSSI%10 + 0x30;
			RSSI_Buf[3]='\0';
			//Uart_sentstr(RSSI_Buf);
		    //Uart_sentstr("\r\n");
		}
		RSSI_Timeout++;		*/
		if(KEY_Scan())  //	KEY_Scan()
		{
		    re_re=0;
			//Uart_sentstr("ʼ...TX\r\n");
			SetTX_Mode();		// ÿһʱ䣬һݣ Acknowledge ź
			RF4432_TxPacket(TxBuf);
			//CLOSE_RX_OK;	//ϨָLED
			RLED=0 ;
			delay_ms(50);
			 RLED=1 ;
		    SetRX_Mode();
			delay_ms(50);
		}
			
		
		if(RF4432_RxPacket(RxBuf))  //
		{
		    
		    //Uart_sentstr("յ...RX:");
		    for(i=0;i<RxBuf_Len;i++)	
			{
				;//Uart_sendB(RxBuf[i]);
			}
			//Uart_sentstr("\r\n");
							
			chksum = 0;
			for(i=0;i<RxBuf_Len-1;i++)  //Checksum
			{
        	    chksum += RxBuf[i];          	 		 	
        	}
			
			if(( chksum == RxBuf[9] )&&( RxBuf[0] == 0x41 ))  //У
     		{
				LED=0;
				re_re=1;
				delay_ms(60);
		        LED=1;
			    SetRX_Mode();//Uart_sentstr("Уɹ...RX OK\r\n\r\n");
     			;//OPEN_RX_OK;	//ָLED
        	}
			else
			{
			    SetRX_Mode();//Uart_sentstr("Уʧ...RX ERROR\r\n\r\n");
			}
		}//end if(RF4432_RxPacket())
    }//end while
}	
